#ifndef VC1DECODER_H
#define VC1DECODER_H

#include <QList>

#include "vdpaucontext.h"



class VC1Frame
{
public:
	VC1Frame() {
		data = NULL;
	}
	~VC1Frame() {
		if ( data ) delete data;
	}
	VdpPictureInfoVC1 info;
	int dataLength;
	uint8_t *data;
};



class VC1Decoder
{
public:
	VC1Decoder( VDPAUContext *v );
	~VC1Decoder();
	bool init();
	VdpVideoSurface getNextFrame();
	
	uint32_t width, height;
	double ratio;
	
private:
	VDPAUContext *vc;
	VdpDecoderProfile profile;
	VdpDecoder decoder;
	VdpVideoSurface surfaces[NUMSURFACES];
	VdpVideoSurface backwardRef, forwardRef, currentSurface;
	int currentFrame;
	QList< VC1Frame* > frames;	
};
#endif // VC1DECODER_H
